import FileObject from './obj.file';
export default class UploadFile {
    private $file;
    constructor(file: FileObject);
    /**
     * A unique UUID referencing this file in the Flatfile system
     */
    readonly id: string;
    /**
     * The original filename on the user's system
     */
    readonly filename: string;
    /**
     * The size of the file in bytes
     */
    readonly filesize: number;
    /**
     * The type of file
     */
    readonly filetype: string;
    /**
     * A securely signed url giving you temporary access to download the file
     */
    readonly url: string;
}
